//+------------------------------------------------------------------+
//|                                              ClassMasterFile.mqh |
//|                                                 Copyright DC2008 |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "DC2008"
#property link      "http://www.mql5.com"
//---   
#include <Files\FileTxt.mqh>
#include <InitMasterWindows.mqh>
//+------------------------------------------------------------------+
//|   CMasterFile                                               |
//+------------------------------------------------------------------+
class CMasterFile
  {
public:
   CFileTxt          Coder;
   void              Run(string g_file,
                         string g_name,
                         int g_X,
                         int g_Y,
                         int g_B,
                         int g_C,
                         int count);
  };
//+------------------------------------------------------------------+
//|  Run  CMasterFile                                     |
//+------------------------------------------------------------------+
void CMasterFile::Run(string g_file,
                      string g_name,
                      int g_X,
                      int g_Y,
                      int g_B,
                      int g_C,
                      int count)
  {
   string s_C;
   if(g_C==CORNER_LEFT_UPPER) s_C="CORNER_LEFT_UPPER";
   if(g_C==CORNER_RIGHT_UPPER) s_C="CORNER_RIGHT_UPPER";
   if(g_C==CORNER_LEFT_LOWER) s_C="CORNER_LEFT_UPPER";
   if(g_C==CORNER_RIGHT_LOWER) s_C="CORNER_RIGHT_UPPER";
   Coder.Open(g_file+".mq5",2);
//---
   Coder.WriteString("//****** : "+g_file+".mq5\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//|         MasterWindows Copyright DC2008 |\n");
   Coder.WriteString("//|                                              http://www.mql5.com |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("#property copyright \"DC2008\"\n");
   Coder.WriteString("//---   \n");
   Coder.WriteString("#include <ClassWin.mqh>\n");
   Coder.WriteString("int Mint[][3]=\n");
   Coder.WriteString("  {\n");
   for(int i=0; i<count; i++)
     {
      Coder.WriteString("     {"+(string)MintNEW[i][0]+","+(string)MintNEW[i][1]+","+(string)MintNEW[i][2]+"},\n");
     }
   Coder.WriteString("     {}\n");
   Coder.WriteString("  };\n");
   Coder.WriteString("string Mstr[][3]=\n");
   Coder.WriteString("  {\n");
   for(int i=0; i<count; i++)
     {
      Coder.WriteString("     {\""+MstrNEW[i][0]+"\",\""+MstrNEW[i][1]+"\",\""+MstrNEW[i][2]+"\"},\n");
     }
   Coder.WriteString("     {}\n");
   Coder.WriteString("  };\n");
//---
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//|  CMasterWindows ( )                            |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("class CMasterWindows:public CWin\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("private:\n");
   Coder.WriteString("   long              Y_hide;          //   \n");
   Coder.WriteString("   long              Y_obj;           //   \n");
   Coder.WriteString("   long              H_obj;           //   \n");
   Coder.WriteString("public:\n");
   Coder.WriteString("   int               on_hide;         //  HIDE \n");
   Coder.WriteString("   CArrayString      units;           //   \n");
   Coder.WriteString("   void              CMasterWindows() {on_event=false; on_hide=false;}\n");
   Coder.WriteString("   void              Run();           //    \n");
   Coder.WriteString("   void              Hide();          // :  \n");
   Coder.WriteString("   void              Deinit()         {ObjectsDeleteAll(0,0,-1); Comment(\"\");}\n");
   Coder.WriteString("   virtual void      OnEvent(const int id,\n");
   Coder.WriteString("                             const long &lparam,\n");
   Coder.WriteString("                             const double &dparam,\n");
   Coder.WriteString("                             const string &sparam);\n");
   Coder.WriteString("  };\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//|  Run  CMasterWindows                                  |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("void CMasterWindows::Run()\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("   ObjectsDeleteAll(0,0,-1);\n");
   Coder.WriteString("   Comment(\"   MasterWindows for MQL5  DC2008\");\n");
   Coder.WriteString("//---       \n");
//---
   Coder.WriteString("   SetWin(\""+g_name+"\","+(string)g_X+","+(string)g_Y+","+(string)g_B+","+s_C+");\n");
//---
   Coder.WriteString("   Draw(Mint,Mstr,"+(string)count+");\n");
   Coder.WriteString("  }\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//|  Hide  CMasterWindows                                 |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("void CMasterWindows::Hide()\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("   Y_obj=w_ydelta;\n");
   Coder.WriteString("   H_obj=Property.H;\n");
   Coder.WriteString("   Y_hide=ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0)-Y_obj-H_obj;;\n");
   Coder.WriteString("//---\n");
   Coder.WriteString("   if(on_hide==false)\n");
   Coder.WriteString("     {\n");
   Coder.WriteString("      int n_str=units.Total();\n");
   Coder.WriteString("      for(int i=0; i<n_str; i++)\n");
   Coder.WriteString("        {\n");
   Coder.WriteString("         long y_obj=ObjectGetInteger(0,units.At(i),OBJPROP_YDISTANCE);\n");
   Coder.WriteString("         ObjectSetInteger(0,units.At(i),OBJPROP_YDISTANCE,(int)y_obj+(int)Y_hide);\n");
   Coder.WriteString("         if(StringFind(units.At(i),\".Button0\",0)>0)\n");
   Coder.WriteString("            ObjectSetString(0,units.At(i),OBJPROP_TEXT,CharToString(MAX_WIN));\n");
   Coder.WriteString("        }\n");
   Coder.WriteString("     }\n");
   Coder.WriteString("   else\n");
   Coder.WriteString("     {\n");
   Coder.WriteString("      int n_str=units.Total();\n");
   Coder.WriteString("      for(int i=0; i<n_str; i++)\n");
   Coder.WriteString("        {\n");
   Coder.WriteString("         long y_obj=ObjectGetInteger(0,units.At(i),OBJPROP_YDISTANCE);\n");
   Coder.WriteString("         ObjectSetInteger(0,units.At(i),OBJPROP_YDISTANCE,(int)y_obj-(int)Y_hide);\n");
   Coder.WriteString("         if(StringFind(units.At(i),\".Button0\",0)>0)\n");
   Coder.WriteString("            ObjectSetString(0,units.At(i),OBJPROP_TEXT,CharToString(MIN_WIN));\n");
   Coder.WriteString("        }\n");
   Coder.WriteString("     }\n");
   Coder.WriteString("//---\n");
   Coder.WriteString("   ChartRedraw();\n");
   Coder.WriteString("   on_hide=!on_hide;\n");
   Coder.WriteString("  }\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//|    OnChartEvent  CMasterWindows       |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("void CMasterWindows::OnEvent(const int id,\n");
   Coder.WriteString("                             const long &lparam,\n");
   Coder.WriteString("                             const double &dparam,\n");
   Coder.WriteString("                             const string &sparam)\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("   if(on_event) //   \n");
   Coder.WriteString("     {\n");
//---
   Coder.WriteString("      //---   OnChartEvent\n");
   Coder.WriteString("      STR1.OnEvent(id,lparam,dparam,sparam);\n");
   Coder.WriteString("      STR2.OnEvent(id,lparam,dparam,sparam);\n");
   Coder.WriteString("      STR3.OnEvent(id,lparam,dparam,sparam);\n");
   Coder.WriteString("      STR4.OnEvent(id,lparam,dparam,sparam);\n");
   Coder.WriteString("      STR5.OnEvent(id,lparam,dparam,sparam);\n");
   Coder.WriteString("      STR6.OnEvent(id,lparam,dparam,sparam);\n");
//---
   if(MintNEW[0][1]==0 || MintNEW[0][1]==1)
     {
      Coder.WriteString("      //---   Close   \n");
      Coder.WriteString("      if(id==CHARTEVENT_OBJECT_CLICK\n");
      Coder.WriteString("         && StringFind(sparam,\""+g_name+"\",0)>=0\n");
      Coder.WriteString("         && StringFind(sparam,\".Button1\",0)>0)\n");
      Coder.WriteString("        {\n");
      Coder.WriteString("         ExpertRemove();\n");
      Coder.WriteString("        }\n");
     }
//---
   if(MintNEW[0][1]==0 || MintNEW[0][1]==2)
     {
      Coder.WriteString("      //---   Hide   \n");
      Coder.WriteString("      if(id==CHARTEVENT_OBJECT_CLICK\n");
      Coder.WriteString("         && StringFind(sparam,\""+g_name+"\",0)>=0\n");
      Coder.WriteString("         && StringFind(sparam,\".Button0\",0)>0)\n");
      Coder.WriteString("        {\n");
      Coder.WriteString("         Hide();\n");
      Coder.WriteString("        }\n");
     }
//---
   Coder.WriteString("      //---   \n");
   Coder.WriteString("      if(id==CHARTEVENT_OBJECT_CREATE)\n");
   Coder.WriteString("        {\n");
   Coder.WriteString("         if(StringFind(sparam,\""+g_name+"\",0)>=0) units.Add(sparam);\n");
   Coder.WriteString("        }\n");
//---
   Coder.WriteString("     }\n");
   Coder.WriteString("  }\n");
   Coder.WriteString("//---   \n");
   Coder.WriteString("CMasterWindows MasterWin;\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//| Expert initialization function                                   |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("int OnInit()\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("//---   \n");
   Coder.WriteString("   MasterWin.Run();\n");
   Coder.WriteString("   return(0);\n");
   Coder.WriteString("  }\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//| Expert deinitialization function                                 |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("void OnDeinit(const int reason)\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("//---    (  )\n");
   Coder.WriteString("   MasterWin.Deinit();\n");
   Coder.WriteString("  }\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("//| Expert Event function                                            |\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("void OnChartEvent(const int id,\n");
   Coder.WriteString("                  const long &lparam,\n");
   Coder.WriteString("                  const double &dparam,\n");
   Coder.WriteString("                  const string &sparam)\n");
   Coder.WriteString("  {\n");
   Coder.WriteString("//---   OnChartEvent   \n");
   Coder.WriteString("   MasterWin.OnEvent(id,lparam,dparam,sparam);\n");
   Coder.WriteString("  }\n");
   Coder.WriteString("//+------------------------------------------------------------------+\n");
   Coder.WriteString("\n");
//---
   Coder.Close();
  }
//+------------------------------------------------------------------+
